// Move_To_MoveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Move_To_Move.h"
#include "Move_To_MoveDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
	HICON m_hIconMISC1, m_hIconMISC2;
	UINT m_uTimerID_A;
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_icoabout;
	//}}AFX_DATA


	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATICABOUT, m_icoabout);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_hIconMISC1 = AfxGetApp()->LoadIcon(IDI_MISC1ICON);
	m_hIconMISC2 = AfxGetApp()->LoadIcon(IDI_MISC2ICON);

	m_uTimerID_A = SetTimer(IDD_ABOUTBOX,1,NULL);

	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
 
	tm *vtma;
	time_t vtime_ta;

	time(&vtime_ta);
	vtma = localtime(&vtime_ta);

	if ((vtma->tm_sec % 2) == 0)
		m_icoabout.SetIcon (m_hIconMISC1);
	else
		m_icoabout.SetIcon (m_hIconMISC2);


	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}

void CAboutDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	KillTimer(m_uTimerID_A);
	// TODO: Add your message handler code here
	
}

/////////////////////////////////////////////////////////////////////////////
// CMove_To_MoveDlg dialog

CMove_To_MoveDlg::CMove_To_MoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMove_To_MoveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMove_To_MoveDlg)
	m_strSlideLineSize = 0;
	m_strSlidePageSize = 0;
	m_strSlideCurrentPosition = 0;
	m_strProgressCurrentPosition = 0;
	m_SelectedTime = _T("No");
	m_clock = _T("");
	m_clockperiod = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	bSelect = false;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MISC1ICON);

	m_hIconARWB = AfxGetApp()->LoadIcon(IDC_ARWICON_B);
	m_hIconARWG = AfxGetApp()->LoadIcon(IDI_ARWICON_G);
	m_hIconARWR = AfxGetApp()->LoadIcon(IDI_ARWICON_R);

	m_hIconINIT = AfxGetApp()->LoadIcon(IDI_INITICON);
	m_hIconSELECT = AfxGetApp()->LoadIcon(IDI_SELECTICON);
	m_hIconNOSELECT = AfxGetApp()->LoadIcon(IDI_NOSELECTICON);

	m_hIconOPENEYE = AfxGetApp()->LoadIcon(IDI_OPENEYEICON);
	m_hIconCLOSEEYE = AfxGetApp()->LoadIcon(IDI_CLOSEEYEICON);

	m_hIconN0 = AfxGetApp()->LoadIcon(IDI_ICONN0);
	m_hIconN1 = AfxGetApp()->LoadIcon(IDI_ICONN1);
	m_hIconN2 = AfxGetApp()->LoadIcon(IDI_ICONN2);
	m_hIconN3 = AfxGetApp()->LoadIcon(IDI_ICONN3);

	m_hIconHELO1 = AfxGetApp()->LoadIcon(IDI_HELO1ICON);
	m_hIconHELO2 = AfxGetApp()->LoadIcon(IDI_HELO2ICON);

    m_hbitmap1.LoadBitmap(IDB_MANAA1);
    m_hbitmap2.LoadBitmap(IDB_MANAA2);
	m_hbitmap3.LoadBitmap(IDB_MANAA3);
    m_hbitmap4.LoadBitmap(IDB_MANAA4);
}

void CMove_To_MoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMove_To_MoveDlg)
	DDX_Control(pDX, IDC_STATICBT, m_framebt);
	DDX_Control(pDX, IDC_BITMAP, m_bitmap);
	DDX_Control(pDX, IDC_STATICTIME, m_ico5);
	DDX_Control(pDX, IDC_SLIDERSECOND, m_sliderSecond);
	DDX_Control(pDX, IDC_SLIDERMINUTE, m_sliderminute);
	DDX_Control(pDX, IDC_SLIDERHOUR, m_sliderhour);
	DDX_Control(pDX, IDC_STATICICO0, m_ico0);
	DDX_Control(pDX, IDC_STATICICO1, m_ico1);
	DDX_Control(pDX, IDC_STATICICO2, m_ico2);
	DDX_Control(pDX, IDC_STATICICO4, m_ico4);
	DDX_Control(pDX, IDC_STATICICO3, m_ico3);
	DDX_Control(pDX, IDC_PROGRESS2, m_progress2);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress1);
	DDX_Control(pDX, IDC_TAB1, m_tab1);
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	DDX_Text(pDX, IDC_STATIC_LINESIZE, m_strSlideLineSize);
	DDX_Text(pDX, IDC_STATIC_PAGESIZE, m_strSlidePageSize);
	DDX_Text(pDX, IDC_STATIC_SLIDERPOSITION, m_strSlideCurrentPosition);
	DDX_Text(pDX, IDC_STATIC_PROGRESSPOSITION, m_strProgressCurrentPosition);
	DDX_Text(pDX, IDC_STATIC_SELECTEDTIME, m_SelectedTime);
	DDX_Text(pDX, IDC_STATICCLOCK, m_clock);
	DDX_Text(pDX, IDC_STATICCLOCKPERIOD, m_clockperiod);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMove_To_MoveDlg, CDialog)
	//{{AFX_MSG_MAP(CMove_To_MoveDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMove_To_MoveDlg message handlers

BOOL CMove_To_MoveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  //  m_bitmap.SetBitmap(m_hbitmap);

	m_ico3.SetIcon (m_hIconARWB);
	m_ico4.SetIcon (m_hIconARWB);
	m_ico1.SetIcon (m_hIconINIT);
	m_ico0.SetIcon (m_hIconN0);

//*********************** TabComtrol ***********************
	TC_ITEM TabCtrlItem;
	TabCtrlItem.mask = TCIF_TEXT;
	TabCtrlItem.pszText = "1st Tab";
	m_tab1.InsertItem( 0, &TabCtrlItem );
	TabCtrlItem.pszText = "2nd Tab";
	m_tab1.InsertItem( 1, &TabCtrlItem );
	TabCtrlItem.pszText = "3th Tab";
	m_tab1.InsertItem( 2, &TabCtrlItem );	

//*********************** Slider *****************************
	m_slider1.SetRange(1, 60);
	m_slider1.SetTicFreq(5);

	m_sliderhour.SetRange(1, 60);
	m_sliderhour.SetTicFreq(5);

	m_sliderminute.SetRange(1, 60);
	m_sliderminute.SetTicFreq(5);

	m_sliderSecond.SetRange(1, 60);
	m_sliderSecond.SetTicFreq(5);

//*********************** Progress ****************************
	m_progress1.SetRange( 0, 60 );

	m_progress2.SetRange( 0, 60 );

	m_strSlideLineSize = m_slider1.GetLineSize( );
	m_strSlidePageSize = m_slider1.GetPageSize( );
	m_strSlideCurrentPosition = m_slider1.GetPos( );

	m_strProgressCurrentPosition = m_progress1.GetPos( );

	m_uTimerID = SetTimer(IDD_MOVE_TO_MOVE_DIALOG,1,NULL);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMove_To_MoveDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMove_To_MoveDlg::OnPaint() 
{

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	
	}
	else
	{
		CDialog::OnPaint();
	}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMove_To_MoveDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMove_To_MoveDlg::OnTimer(UINT nIDEvent) 
{
	CHAR  sz0[40];
    
	time(&vtime_t);
	vtm = localtime(&vtime_t);
	int vhtime;

//***************************** Display Icons ************************

	if ((bSelect) && (vtime_t == seltime + 7))
	{

		m_ico4.SetIcon (m_hIconARWR);
		m_ico3.SetIcon (m_hIconARWR);
		m_ico1.SetIcon (m_hIconNOSELECT);

		bSelect = false;
	}

	if ((vtm->tm_sec % 2) == 0)
	{
		m_ico5.SetIcon (m_hIconHELO1);
		m_ico2.SetIcon (m_hIconOPENEYE);
	}
	else
	{
		m_ico5.SetIcon (m_hIconHELO2);
    	m_ico2.SetIcon (m_hIconCLOSEEYE);
	}
//********************** Slider & Digital Clock *******************

    if (vtm->tm_hour > 12)
		itoa(vtm->tm_hour - 12 , sz0, 10);
	else
		itoa(vtm->tm_hour , sz0, 10);
    strcat(sz0, " : ");

	itoa(vtm->tm_hour, sz, 10);
    strcat(sz, " : ");

	itoa(vtm->tm_min, &sz0[strlen(sz0)], 10);
    strcat(sz0, " : ");

	itoa(vtm->tm_min, &sz[strlen(sz)], 10);
    strcat(sz, " : ");

    itoa(vtm->tm_sec, &sz0[strlen(sz0)], 10);

    itoa(vtm->tm_sec, &sz[strlen(sz)], 10);

	if (vtm->tm_hour > 12) 
		strcat(sz0, " PM");
	else
		strcat(sz0, " AM");

	m_clock = sz0;

	if (vtm->tm_hour > 12) 
		m_clockperiod = " PM";
	else
		m_clockperiod = " AM";

	if (vtm->tm_hour < 12)
		vhtime = (vtm->tm_hour * 5) + (vtm->tm_min/12);
	else 
		vhtime = ((vtm->tm_hour - 12) * 5) + (vtm->tm_min/12);

	m_sliderhour.SetPos(vhtime);
	m_sliderminute.SetPos( vtm->tm_min );
	m_sliderSecond.SetPos( vtm->tm_sec );

//************************** Slider Progress  *********************    
	
	m_slider1.SetPos( vtm->tm_sec );

	m_progress1.SetPos( vtm->tm_sec );
	m_progress2.SetPos( vtm->tm_sec );
//****************************** Bitmap ***************************
	if ((vtm->tm_sec % 4) == 0)	   	
		m_bitmap.SetBitmap(m_hbitmap1);	
	if ((vtm->tm_sec % 4) == 1)	
       m_bitmap.SetBitmap(m_hbitmap2);
    if ((vtm->tm_sec % 4) == 2)
       m_bitmap.SetBitmap(m_hbitmap3);
    if ((vtm->tm_sec % 4) == 3)
 	   m_bitmap.SetBitmap(m_hbitmap4);	
  

	UpdateData(FALSE);

	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}

void CMove_To_MoveDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	KillTimer(m_uTimerID);
	// TODO: Add your message handler code here
	
}

void CMove_To_MoveDlg::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult) 
{

	int ntab = m_tab1.GetCurSel();
		
	switch(ntab)
	{
	case 0:
		{		
		m_strSlideLineSize = m_slider1.GetLineSize( );
		m_strSlidePageSize = m_slider1.GetPageSize( );
		m_strSlideCurrentPosition = m_slider1.GetPos( );

		m_strProgressCurrentPosition = m_progress1.GetPos( );

		m_ico3.SetIcon (m_hIconARWG);
		m_ico4.SetIcon (m_hIconARWG);
		m_ico1.SetIcon (m_hIconSELECT);
		m_ico0.SetIcon (m_hIconN1);

		m_SelectedTime = sz;
		seltime = vtime_t;
	
		bSelect = true;

		break;
		}
	case 1:
		{
		m_strSlideLineSize = m_slider1.GetLineSize( );
		m_strSlidePageSize = m_slider1.GetPageSize( );
		m_strSlideCurrentPosition = m_slider1.GetPos( );

		m_strProgressCurrentPosition = m_progress1.GetPos( );

		m_ico3.SetIcon (m_hIconARWG);
		m_ico4.SetIcon (m_hIconARWG);
		m_ico1.SetIcon (m_hIconSELECT);
		m_ico0.SetIcon (m_hIconN2);

		m_SelectedTime = sz;

		bSelect = true;
		seltime = vtime_t;
		break;
		}
	case 2:
		{
		m_strSlideLineSize = m_slider1.GetLineSize( );
		m_strSlidePageSize = m_slider1.GetPageSize( );
		m_strSlideCurrentPosition = m_slider1.GetPos( );

		m_strProgressCurrentPosition = m_progress1.GetPos( );

		m_ico3.SetIcon (m_hIconARWG);
		m_ico4.SetIcon (m_hIconARWG);
		m_ico1.SetIcon (m_hIconSELECT);
		m_ico0.SetIcon (m_hIconN3);

		m_SelectedTime = sz;

		bSelect = true;
		seltime = vtime_t;
		break;
		}
	}

	UpdateData(FALSE);  

	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CMove_To_MoveDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	// TODO: Add your control notification handler code here
	
}


